;*******************************************************************************
;				FM-radio_ATtiny2313.asm
;	 FM-   RDA5807M  LCD- Nokia5110
;  ATtiny2313    .  8 .
; 		  :
;-*-   +   - ,    
;-*-      +   -
;-*-   
;-*-      EEPROM
;-*-     RDA5807M
;-*-        
;-*-      
;-*-   -     
;-*-    I2C
;
;  :
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
; PB7 - .   -
;
; PD0 -  +F
; PD1 -  -F
; PD2 -  +St
; PD3 -  -St
; PD4 - (SDA) -   
; PD5 - (SCL) -   
;
;******************************************************************************* 
	;     /
    .NOLIST                 	; 
	.include "tn2313def.inc"	;   - ATtiny2313
    .LIST                   	; 
    .device ATtiny2313         	; 

  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		;   LCD
	.equ ram_read_en = 0 	;: 0-   FLASH, 1-   
	.def time	=	r21		;  
	.def F_3H	=	r22		;.   
	.def F_3L	=	r23		;.   
	.def freq	=	r24		;  

	;  LCD  ATtiny2313
	.equ LCD_DC_port  = PORTB
	.equ LCD_DC   = 1			;  - /  PORTB.1
	.equ LCD_SCE_port = PORTB
	.equ LCD_SCE  = 2			; .    PORTB.2
	.equ LCD_SDIN_port = PORTB
	.equ LCD_SDIN = 3			;   PORTB.3
	.equ RES_port = PORTB
	.equ RES 	  = 4			;    PORTB.4
	.equ LCD_SCLK_port = PORTB
	.equ LCD_SCLK = 5			;   PORTB.5
	
;===============================================================================
	.DSEG				;    SRAM ()
	.ORG 0x060			;   
	
	decnum: .BYTE 5			;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	;  
	
;=============================================================================
	.ESEG				;    EEPROM
	 Fst_EE:	.BYTE 1 		;   ( )
;=============================================================================
  .CSEG		;  
  .ORG 0 	; 
  		rjmp RESET	;   
		reti 		; rjmp INT0addr      ;  0
 		reti 		; rjmp INT1addr      ;  1
 		reti 		; rjmp ICP1addr      ;/ 1 
 		reti        ; rjmp OC1Aaddr  	 ;/ 1  
 		reti 		;/ 1   
     	rjmp OVF_T0 		;/ 0   
 		reti 		; rjmp URXC0addr     ; UART  
 		reti		; rjmp UDRE0addr     ; UART   
 		reti 		; rjmp UTXC0addr     ; UART  
 		reti 		; rjmp ACIaddr       ;  
 		reti 		; rjmp PCINTaddr     ;  .   .
 		reti 	    ; rjmp OC1Baddr  	 ;/ 1   
 		reti       	; rjmp OC0Aaddr  	 ;/ 0   
 		reti		; rjmp OC0Baddr   	 ;/ 0   
 		reti		; rjmp USI_STARTaddr ;USI   
 		reti		; rjmp USI_OVFaddr   ;USI 
 		reti		; rjmp ERDYaddr      ;EEPROM  
 		reti		; rjmp WDTaddr       ;  
 		
;===========================================================================
RESET:		;   ,  
		;  
		ldi		temp, RAMEND		;  
		out		SPL, temp			;
		cli							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00000110			;   RES  SE 
		out PORTB,temp   			;
			;  
	 ;	ldi temp,0b00000000			;      
	;	out DDRC,temp   			;
	;	ldi temp,0b11111111			;
	;	out PORTC,temp   			;  
		
			;  D
	 	ldi temp,0b00000000			;   D  
		out DDRD,temp				;
		ldi temp,0b11111111			;
		out PORTD,temp				;  
		
			;  0
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;    T0 
		out TCNT0,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		ldi temp,0b00000010			; .    T0
		out TIMSK,temp				;
		
		sei                         ;  
		
;------------------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R20  0
		brne PC-1					;
	.ENDMACRO
;===================   ==================================
			; 
	;	sbi PORTB,0					;  
		sbi RES_port,RES			;   RES
		DELAY 1						;  32 
		cbi LCD_SCE_port,LCD_SCE	;.  LCD
		rcall Delay10us				; 10 
		
		;  LCD
		cbi RES_port,RES			;   LCD
		DELAY 1						;   32 
		sbi RES_port,RES			;   LCD
		;
		rcall Delay10us				; 10 
		
		sbi LCD_SCE_port,LCD_SCE	;.  LCD
		DELAY 1						;  32 
		rcall lcd_init				; LCD 
		rcall lcd_clr				; LCD
		;    LCD
		ldi temp,0x80				;     =0
		rcall lcd_XY				;
		ldi temp,0x40				;  1-  Y = 0
		rcall lcd_XY				;
		;    
		ldi ZL,low((Messg1)*2) 		;  
		ldi ZH,high((Messg1)*2)		; " 87-108 "
		rcall Str_LCD				; .  LCD
		
;-----------------------------------------------------------------------------
		;  RDA5807
		rcall iic_init				;   I2C
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		rcall Rd_St					;     FLASH
		;
		DELAY 20					; 656 
		ldi temp,0b11110010			;(02H) .,,, 
	;	ldi temp,0b11010010			;(02H) .,,, 	
		mov r5,temp					; - 
		rcall Config_RDA5807		; RDA5807
		DELAY 20					; 656 
		
		ldi ZL,LOW((Messg3)*2)		;   
		ldi ZH,HIGH((Messg3)*2)		;  ". "
		
		;    LCD
		ldi temp,0x80			;     =0
		rcall lcd_XY			;
		ldi temp,5				;  6-  Y = 0
		rcall lcd_XY			;
		rcall Str_LCD			;   
		
		clr r2						;  
;------------------------------------------------------------------
main: 			; 
		in temp,PIND				; 
		com temp					; 
		andi temp,0x0F				;  
		mov r1,temp					;   
		;   ()
		DELAY 1						; 32  
		cp r1,r2					;  
		breq main					;  -  
		
		;  , .  
		mov temp,r2					;   
		sbrc temp,0					;   +F
		rcall freq_Up				;
		sbrc temp,1					;   +F
		rcall freq_Down				;
		sbrc temp,2					;   +S
		rcall St_Up					;
		sbrc temp,3					;   -S
		rcall St_Down				;
		
		rjmp main					; , -  
		
;===========================================================================
freq_Up:	;   "+"   
		clr r2						;  
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
		
	;	ldi temp,0b11110011			;(02H) .,,, 
		ldi temp,0b11010011			;(02H) .,,, 
		rjmp nastr					;  
		
;===========================================================================
freq_Down:		;   "-"   
		clr r2						;  
		
		dec freq					; 
	;	ldi temp,0b11110001			;(02H) .,,, 
		ldi temp,0b11010001			;(02H) .,,, 
		
nastr:	mov r5,temp					; - 
		rcall Set_Fq				; 
		
nov_m:	cbi PORTB,7					;  
		DELAY 15					;
		
		rcall Read_RDA5807			;   RDA5807
		
		lds r17,seek_fm				;  . 
		sbrs r17,6					;   , -
		rjmp nov_m					;  . 
		
		DELAY 10					;
		ldi ZL,LOW((Messg5)*2)		;  
		ldi ZH,HIGH((Messg5)*2)		; ""
		rcall Read_RDA5807			;   RDA5807
		lds freq,read_fm			;    
		
		sbrc r17,2					; , -
		sbi PORTB,7					;   
		
	;	ldi temp,0b11110010			;(02H) .,,, 
		ldi temp,0b11010010			;(02H) .,,, 
		mov r5,temp					; - 
		rcall Config_RDA5807		;    /
		
		clr temp					; temp    
		
 		ret
;===========================================================================
 St_Up:			;     FLASH
 		clr r2						;  
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		
		inc temp3					;  
 		cpi temp3,13				;    > 14-1
 		brlo st_u					;
 		ldi temp3,13				;
 		
 		rjmp st_u					;
 		
;---------------------------------------------------------------------------
		
St_Down:		;     FLASH
		clr r2						;  
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		;  
 		dec temp3					;  
 		tst temp3					;     < 0
 		brpl num_s					;
 		ldi temp3,0					;
 		rjmp st_set					;
 num_s:	tst temp3					;  =0,   
 		breq st_set					;
 		;     . 
 st_u:	cbi PORTB,7					;  
 		push temp3					;
		adiw Z,16					;    . 
		dec temp3					;
		brne PC-2					;
		pop temp3					;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		
	;	ldi temp,0b11110010			;(02H) .,,, 
		ldi temp,0b11010010			;(02H) .,,, 
		mov r5,temp					;
		rcall Config_RDA5807		;    /
		
		DELAY 1						;
		rcall Read_RDA5807			;   RDA5807
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		sbi PORTB,7					;   
		
		clr temp					; temp    
		
		ret
		
;===========================================================================
;			 /   (0) RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		set						;    -  ASC
		rcall IIC_Recieve		;   
		sts seek_fm,temp		;    . 
		clt						;    -  NASC
		rcall IIC_Recieve		;   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Stop			;  
		
		ret
		
;===========================================================================
;	 /     , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		clr freq					;
Rd_EEP:	sbic EECR,EEWE				;   
		rjmp Rd_EEP					;
		out EEAR,YL					; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		rcall Print					;   
Set_Fq:	in r25,SREG					;  . SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				; 
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10001101			;(02L): Fclk=32.768kHz, RDS_EN,
		rcall IIC_Send				; 			NEW_METHOD, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		rcall iic_stop 				; 
		
		;    ,  YH:YL   
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
Wr_EEP:	sbic EECR,EEWE				;  
		rjmp Wr_EEP					;   EEWE
		out EEAR,YL					; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		;
		out SREG,r25			  	;  
		
		ret
;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
t_1:	tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
;		       LCD 
;---------------------------------------------------------------------------
Print:		;    
		;    LCD
		ldi temp,0x80			;     =0
		rcall lcd_XY			;
		ldi temp,5				;  6-  Y = 0
		rcall lcd_XY			;
		rcall Str_LCD			;   
 Prnt_F:		;      
		;    LCD
		ldi temp,0x86			;   =6
		mov r6,temp				;  
		rcall lcd_XY			;
		ldi temp,2				;  3-  Y = 0
		rcall lcd_XY			;
		;    
		clr r18					;
		ldi r17,0x3				;    -
		ldi temp,0x66			; 870(10)  -> 366 (16)
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		ldi YL,LOW(decnum)		;.  X . .   
		clr YH					;
		ldi temp,3				; .    
		add YL,temp				;
		
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall Dig_x2			;  LCD 
		rjmp PC+2				
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		;  LCD 
		ldI temp,0x20			;   
		rcall lcd_put_char		;
		;   
		ldi temp,0xAA			; = 87+C+C+C = AA
		rcall lcd_XY			;
		ldi temp,0x03			;  4 
		rcall lcd_XY			;
		ldI temp,0x3C			; 
	;	ldI temp,126			; 
		rcall lcd_put_char		;  LCD 
		;     
		ldi temp,6				;    1 
		add r6,temp				;  
		ldi temp,0x02			;  3 
		rcall lcd_XY			;
		
		ld temp,-Y				; .  
		rcall Dig_x2			;   
		
		;    ""
		ldi temp,0xBD			; = 0xBD
		rcall lcd_XY			;
		ldi temp,0x03			;  4 
		rcall lcd_XY			;
		
		ldi ZL,LOW((Messg4)*2)	;   
		ldi ZH,HIGH((Messg4)*2)	;  " "
		rcall Str_LCD			;   
		
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:temp,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;===========================================================================
		;      

  Messg1: .DB  '','',' ','8','7',':','1','0','8',' ','','','',' ', 0
  Messg2: .DB  '','','','','','',' ','','','','','','.',' ', 0
  Messg3: .DB  '','','','',';','','','','','','','','','', 0
  Messg4: .DB  '','','',0, 0
  Messg5: .DB  '','','','','','','','','','','','','',' ', 0

;=================================================================================

	freq_st:		;  FM-  
 	.DB  41,' ',' ','','','','','','','','','',' ',' ',' ',0   	; 	    911  29
  	.DB  46,' ',' ',' ','','','','',' ','','',' ',' ',' ',' ',0 	   	; FM	    916	 2E
  	.DB 121,' ',' ',' ','','','','','','','',' ',' ',' ',' ',0   	;	    991	 79
  	.DB 132,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1002	 84
  	.DB 140,' ','','','','','',' ','','','','','','',' ',0   	;   1010	 8C
  	.DB 144,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0  		; FM	   1014	 90
  	.DB 157,' ',' ','','','','',' ','','','','','',' ',' ',0   	; 	   1027	 9D
  	.DB 162,' ','','','','','','',' ','','','','',' ',' ',0  		;    1032	 A2
  	.DB 166,' ',' ',' ','','','','','','','','',' ',' ',' ',0   	;	   1036  A6
  	.DB 177,' ',' ','','','','','','',' ','','',' ',' ',' ',0    	;DJ-FM		   1047  B1
  	.DB 182,' ',' ',' ','','','','','',' ','','',' ',' ',' ',0   	;Kiss FM	   1052  B6
  	.DB 189,'','','','','','','',' ','','','','','',' ',0     	;  1059  BD
  	.DB 199,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0   	; FM		   1069  C7
	.DB 204,' ',' ',' ',' ','','','',' ','','',' ',' ',' ',' ',0  		; FM		   1074  CC
		;
;=================================================================================

;******************************************************************************
	.include "I2C_soft_driv.asm"
 	.include "LCD_driv_rus.asm"	 	; LCD
 	.include "Font6x8_rus.asm" 		;  
 	
;******************************************************************************

.EXIT


;===========================================================================
		;     

  Messg1: .DB  'F','M',' ','8','7','-','1','0','8',' ','M','H','z',' ', 0
  Messg2: .DB  ' ','M','a','n','u','a','l',' ','t','u','n','e',' ',' ', 0
  Messg3: .DB  'S','a','v','e','d',' ','c','h','a','n','n','e','l',' ', 0
  Messg4: .DB  'M','H','z',0, 0
  Messg5: .DB  ' ',' ','A','u','t','o',' ','T','u','n','e',' ',' ',' ', 0



;=================================================================================

	freq_st:		;  FM-  
 	.DB  41,' ',' ','A','v','t','o','R','a','d','i','o',' ',' ',' ',0   	; 	    911  29
  	.DB  46,' ',' ',' ',' ','L','u','x',' ','F','M',' ',' ',' ',' ',0 	   	; FM	    916	 2E
  	.DB 121,' ',' ','P','j','a','t','n','i','t','s','a',' ',' ',' ',0   	;	    991	 79
  	.DB 132,' ','G','a','l','l','a',' ','R','a','d','i','o',' ',' ',0   	; 	   1002	 84
  	.DB 140,'R','a','d','i','o',' ','S','h','a','n','s','o','n',' ',0   	;   1010	 8C
  	.DB 144,' ',' ','P','e','r','e','t','s','-','F','M',' ',' ',' ',0  		; FM	   1014	 90
  	.DB 157,' ','N','a','s','h','e',' ','R','a','d','i','o',' ',' ',0   	; 	   1027	 9D
  	.DB 162,' ','E','u','r','o','p','a',' ','P','l','u','s',' ',' ',0  		;    1032	 A2
  	.DB 166,' ',' ','S','h','a','r','m','a','n','k','a',' ',' ',' ',0   	;	   1036  A6
  	.DB 177,' ',' ',' ',' ','D','J','-','F','M',' ',' ',' ',' ',' ',0    	;DJ-FM		   1047  B1
  	.DB 182,' ',' ',' ','G','o','r','o','d',' ','F','M',' ',' ',' ',0   	;Kiss FM	   1052  B6
  	.DB 189,'R','u','s','s','k','o','e',' ','R','a','d','i','o',' ',0     	;  1059  BD
  	.DB 199,' ',' ',' ',' ','H','i','t',' ','F','M',' ',' ',' ',' ',0   	; FM		   1069  C7
	.DB 204,' ',' ',' ',' ','E','r','a',' ','F','M',' ',' ',' ',' ',0  		; FM		   1074  CC
		;
;============================================================================

